/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*-
 * vim:expandtab:shiftwidth=4:tabstop=4:
 */
#ifndef _AUTH_H_
#define _AUTH_H_

#include <glib.h>
#include "main.h"
#include "pkt.h"

struct auth_instance;

struct auth_type {
    char *name;
    guint16 auth_id;
    gint refcount;
    void *data;
    unsigned int len;

    int (*start_inst)(struct auth_type *at, struct auth_instance *inst);
    int (*stop_inst)(struct auth_type *at, struct auth_instance *inst);

    int (*append_data)(struct auth_instance *inst, struct packet *pkt);

    int (*sign)(struct auth_instance *inst, struct packet *pkt,
                unsigned char *data, int len);
    int (*verify)(struct auth_instance *inst, unsigned char *data, int len,
                  struct packet *pkt);

    int (*shutdown)(struct auth_type *at);
};

struct auth_instance {
    struct auth_type *at;

    void *data;
    unsigned int len;
};

int auth_init(struct daemon *dae);
void auth_shutdown(void);
void auth_unregister(struct auth_type *at);
void auth_register(struct auth_type *at);
struct auth_instance *auth_instance_new(guint16 id);
void auth_instance_free(struct auth_instance *inst);
int auth_choose(guint16 *list, int num);
int auth_append_list(struct packet *pkt);

#endif
