/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*-
 * vim:expandtab:shiftwidth=4:tabstop=4:
 */

#ifndef _CMD_ENUM_H_
#define _CMD_ENUM_H_

#include <glib.h>
#include <net/if.h>

/*
 * this should really be off in a /inlcudes/ style directory somewhere..
 */

enum {
    CMD_LINK_SHOW = 0,
    CMD_TUNNEL_ADD,
    CMD_TUNNEL_SHOW,
    CMD_TUNNEL_DEL,
    CMD_TOPO_SHOW,
    CMD_MAX,
};

struct cipher_stats {
    guint32 enc, dec;
    guint64 enc_bytes, dec_bytes;
};

struct cmd_link_show {
    guint64 rx_packets;
    guint64 missed_packets;
    guint64 tx_packets;
    struct cipher_stats cs;
    guint32 id;
    guint32 addr;
    guint16 port;
    /* dorky */
    guint16 flags;
#define CMD_LINK_F_UP   0x0001 
#define CMD_LINK_F_NEI  0x0002 
#define CMD_LINK_F_INIT 0x0004 
};

struct cmd_tunnel_add {
    guint32 id;
    int num_addrs;
    guint32 addrs[0];
};
struct cmd_tunnel_del {
    guint32 link_id;
    guint32 local_id;
};

struct cmd_tunnel_show {
    guint32 link_id;
    guint32 link_id_forward, link_id_reverse;
    guint32 local_id_forward, remote_id_forward,
            local_id_reverse, remote_id_reverse;
    char dev[IFNAMSIZ];
    guint32 addr; 
    guint32 netmask;
    guint16 flags;
#define CMD_TUNNEL_F_INIT           0x0001 
#define CMD_TUNNEL_F_NEG_FWD        0x0002 
#define CMD_TUNNEL_F_NEG_FWD_ACK    0x0004 
};

#endif
