/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*-
 * vim:expandtab:shiftwidth=4:tabstop=4: 
 */

#ifndef _CONFIG_H_
#define _CONFIG_H_

#include <netinet/in.h>

#include "main.h"
#include "udp.h"
#include "list.h"

/*
 * this struct contains all items that can be configured.
 * we have multiple instances of it depending on the context.. globals,
 * defaults, per daemon config..
 */
struct config {
    /*
     * globals that can be used throughout..
     */
    char *plugin_directory;
    int debug;

    /*
     * per cebolla that are consumed..
     */
    struct sockaddr_in udp_listen;
    struct list_head link_sinc_head;
    struct list_head ip_pool_sinc_head;

    /*
     * per cebolla that are used throughout..
     */
    char *log_file;
    char *management_socket;
    char *lsa_file;
    char *pgp_certificate;
    unsigned long int lsa_retrans_timeout;
    unsigned long int lsa_expiry_timeout;
    unsigned long int lsa_refresh_interval;
    unsigned long int neg_recalc_timeout;
};


int config_parse(struct daemon *dae, char *filename);

extern struct config *global_config;

#endif
