/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*-
 * vim:expandtab:shiftwidth=4:tabstop=4: 
 */
#ifndef _DEBUG_H_
#define _DEBUG_H_

#if 0
#define RETURN(RET) do { \
        printf(__FUNCTION__ "():%d: returning (" #RET ")\n", __LINE__); \
                return RET; } while (0)
#else
#define RETURN(RET) return RET
#endif

void log_stack_trace(void);

#define hexdump(BYTES,LEN, args...) do_hexdump( BYTES, LEN, \
        G_GNUC_PRETTY_FUNCTION "(): " args)

#define bitdump(BYTES,LEN, args...) do_bitdump( BYTES, LEN, \
        G_GNUC_PRETTY_FUNCTION "(): " args)

void do_hexdump(void *bytes, int len, char *fmt, ...);
void do_bitdump(void *bytes, int len, char *fmt, ...);

#endif
