/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*- */

#ifndef _PLUGIN_H_
#define _PLUGIN_H_

#include <gmodule.h>

#include "config.h"
#include "main.h"

struct plugin_data;

typedef int init_plugin_t(struct plugin_data *, struct config *);

struct plugin_data {
    GModule *handle;
    init_plugin_t *init_plugin;
    int (*can_unload)(struct plugin_data *data);
    int (*cleanup)(struct plugin_data *data);
    void *private;
};

int plugin_init(struct daemon *dae);
struct plugin_data * plugin_load(struct config *config, const char *name);
void plugin_unload(struct plugin_data *data);

/* 
 * this is a dummy declaration that should emit a warning if a plugin
 * tries to declare its init_plugin with the wrong arguments..
 */
init_plugin_t init_plugin;

#endif
