/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*-
 * vim:expandtab:shiftwidth=4:tabstop=4:
 *
 *    (c) Copyright 2002 Zach Brown <zab@zabbo.net>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License version 2 as
 *      published by the Free Software Foundation.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <unistd.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>

#include "log.h"

/*
 * the dorkiest libc version
 */

static int rand_fd;

#define RAND_FILE "/dev/urandom"

void 
get_random_bytes(void *buffer, int num_bytes)
{
    ssize_t ret;

    /* 
     * XXX yes, we know this can loop, but only when /dev/urandom is 
     * broken.. *shrug*
     */
    while ( num_bytes ) {
        ret = read(rand_fd, buffer, num_bytes);
        if ( ret > 0 ) {
            buffer += ret;
            num_bytes -= ret;
        }
    }
}

int 
random_init(void)
{
    if ( (rand_fd = open(RAND_FILE, O_RDONLY)) < 0) {
        l_warn("couldn't open " RAND_FILE ": %s\n", strerror(errno));
        return 0;
    }

    return 1;
}
