/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*-
 * vim:expandtab:shiftwidth=4:tabstop=4:
 */
#ifndef _SHELL_H_
#define _SHELL_H_

struct shell_handle {
    int stdin[2];
    int stdout[2];
    int stderr[2];
    int pid;
};

struct shell_handle *shell_start(const char *file, char *const argv[]);
int shell_write(struct shell_handle *handle, const void *buf, size_t count);
int shell_read_stdout(struct shell_handle *handle, void *buf, size_t count);
int shell_read_stderr(struct shell_handle *handle, void *buf, size_t count);
void shell_kill(struct shell_handle *handle);
int shell_finish(struct shell_handle *handle);

#endif
