/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*- */

#ifndef _TOPO_H_
#define _TOPO_H_

struct topo_state;

#include <glib.h>

#include "wire.h"
#include "udp.h"

struct link_topo {
    GHashTable *pending_acks;
};

#include "link.h"

struct topo_state {
    /*
     * we keep a host readable copy of our lsa header in here
     * so that we can get at it easily.  we use this to generate
     * our lsas, too..
     */
    struct w_lsa_header lh;

    GTree *lsa_tree;
    gint file_timeout_id;
    gint lsa_refresh_id;
    /*
     * measured in seconds..
     */
    char *lsa_file;
    int lsa_retrans_timeout;
    int lsa_expiry_timeout;
};


int topo_init(struct daemon *dae, struct socket *sk);
int topo_link_up(struct socket *sk, struct link *link);
void topo_link_down(struct link *link);
void topo_incoming(struct packet *pkt, struct link *link, int type);
int topo_show(struct daemon *dae, void *buf, size_t len);

#endif
