/* -*- mode: c; c-basic-offset: 4; indent-tabs-mode: nil; -*- */

#ifndef _UDP_H_
#define _UDP_H_

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include <glib.h>

struct socket;

#include "pkt.h"
#include "topo.h"

/*
 * no real reason for this to be in this file, I wasn't sure where
 * to put it.
 */
struct ip_block {
    guint32 base;
    int num_words;
    int num_addrs;
    int *mask; /* 0 for allocated, 1 for free */
};

struct socket {
    struct sockaddr_in sin;
    GPollFD pfd;
    GHashTable *link_nei_hash, *link_id_hash;

    struct ip_block *ipb;

    /*
     * used to store our lsa, topo auth stuff, etc..
     */
    struct topo_state ts;

    struct list_head links_head;
};

void socket_sendto(struct socket *sk, struct sockaddr_in *sin, 
        struct packet *pkt);

struct socket * socket_prepare(struct daemon *dae, struct sockaddr_in *sin);
int socket_init(struct daemon *dae);

#endif
